



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Android】添加菜单和监听菜单方法详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Android】添加菜单和监听菜单方法详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 05:32:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>添加菜单</p>
<p>可以在onCreateOptionsMenu或者onPrepareOptionsMenu方法中来添加菜单</p>
<h4>代码添加:</h4>
<pre class="prettyprint linenums">    menu.add((int groupId, int itemId, int order, charsequence title) .setIcon(drawable ID)</pre>
<p>add()方法的四个参数，依次是：</p>
<p>1、组别，如果不分组的话就写Menu.NONE,</p>
<p>2、Id，这个很重要，Android根据这个Id来确定不同的菜单</p>
<p>3、顺序，哪个菜单项在前面由这个参数的大小决定</p>
<p>4、文本，菜单项的显示文本</p>
<p>add()方法返回的是MenuItem对象，调用其setIcon()方法，为相应MenuItem设置Icon</p>
<h5>示例:</h5>
<pre class="prettyprint linenums">	@Override<br />
	public boolean onCreateOptionsMenu(Menu menu) {<br />
		// TODO Auto-generated method stub<br />
		menu.add(0, 1, 1, "设置").setIcon(R.drawable.tab5cog);<br />
		menu.add(0, 2, 1, "关于").setIcon(R.drawable.tab2users);<br />
		menu.add(0, 3, 1, "意见").setIcon(R.drawable.tab3user);<br />
		menu.add(0, 4, 1, "退出").setIcon(R.drawable.tab4wrench);<br />
		return super.onCreateOptionsMenu(menu);<br />
	}</pre>
<h4>布局文件添加:</h4>
<pre class="prettyprint linenums">    getMenuInflater().inflate(R.menu.options_menu, menu);</pre>
<p>调用Activity的getMenuInflater()得到一个MenuInflater，</p>
<p>使用inflate方法来把布局文件中的定义的菜单 加载给 第二个参数所对应的menu对象</p>
<h5>示例:</h5>
<pre class="prettyprint linenums">	@Override<br />
	public boolean onCreateOptionsMenu(Menu menu) {<br />
		// TODO Auto-generated method stub<br />
		//  调用Activity的getMenuInflater()得到一个MenuInflater，<br />
	    //	使用inflate方法来把布局文件中的定义的菜单 加载给 第二个参数所对应的menu对象<br />
		getMenuInflater().inflate(R.menu.main_menu, menu);<br />
		return super.onCreateOptionsMenu(menu);<br />
	}</pre>
<h5>布局文件：</h5>
<p>在res目录下建立一个menu文件夹，并创建布局文件: main_menu.xml</p>
<pre class="prettyprint linenums">	&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
	&lt;menu xmlns:android="http://schemas.android.com/apk/res/android" &gt;<br />
		&lt;item android:id="@+id/menu_setting" android:title="设置" android:icon="@drawable/tab5cog"&gt;&lt;/item&gt;<br />
		&lt;item android:id="@+id/menu_about" android:title="关于" android:icon="@drawable/tab2users"&gt;&lt;/item&gt;<br />
		&lt;item android:id="@+id/menu_idea" android:title="意见" android:icon="@drawable/tab3user"&gt;&lt;/item&gt;<br />
		&lt;item android:id="@+id/menu_exit" android:title="退出" android:icon="@drawable/tab4wrench"&gt;&lt;/item&gt;<br />
	&lt;/menu&gt;</pre>
<h2>菜单项监听:</h2>
<p>只要菜单中的菜单项被点击，都会触发onOptionsItemSelected(MenuItem item)</p>
<p>item参数即为被点击的菜单项，那么需要在此方法内判断哪个Item被点击了，从而实现不同的操作。</p>
<p>对于两种不同的添加菜单方法，监听的方法有一点区别，但本质是一样的。</p>
<h4>代码添加菜单的监听方法</h4>
<pre class="prettyprint linenums">	@Override<br />
	public boolean onOptionsItemSelected(MenuItem item) {<br />
		// TODO Auto-generated method stub<br />
		switch (item.getItemId()) {//得到被点击的item的itemId<br />
		case 1://对应的ID就是在add方法中所设定的Id<br />
			Toast.makeText(MainActivity.this, "设置", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case 2:<br />
			Toast.makeText(MainActivity.this, "关于", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case 3:<br />
			Toast.makeText(MainActivity.this, "意见", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case 4:<br />
			finish();<br />
			break;<br />
		default:<br />
			break;<br />
		}<br />
		return super.onOptionsItemSelected(item);<br />
	}</pre>
<h4>布局文件添加菜单的监听方法</h4>
<pre class="prettyprint linenums">	@Override<br />
	public boolean onOptionsItemSelected(MenuItem item) {<br />
		// TODO Auto-generated method stub<br />
		switch (item.getItemId()) {//得到被点击的item的itemId<br />
		case R.id.menu_setting://这里的Id就是布局文件中定义的Id，在用R.id.XXX的方法获取出来<br />
			Toast.makeText(MainActivity.this, "设置", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case R.id.menu_about:<br />
			Toast.makeText(MainActivity.this, "关于", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case R.id.menu_idea:<br />
			Toast.makeText(MainActivity.this, "意见", Toast.LENGTH_LONG).show();<br />
			break;<br />
		case R.id.menu_exit:<br />
			finish();<br />
			break;<br />
		default:<br />
			break;<br />
		}<br />
		return super.onOptionsItemSelected(item);<br />
	}</pre>
<h3>效果图</h3>
<div>
  <img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130927000710593?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvanVlYmxvZw==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /><br />
  <br /> 
 </div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4m6z0q.html">Asp&period;net上传文件后台通过二进制流发送到其他Url保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jjomq.html">select distinct</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwno6lq.html">DLX &lpar;poj 3074&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e2ljk8.html">mybatis的逆向工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4vdxq.html">基于HTML5技术的电力3D监控应用（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0n3zq.html">Django项目中如何建表？怎样导入数据？</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mor1o9.html">Redis学习笔记&lpar;8&rpar;-发布&sol;订阅</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdknn8.html">Junit单元测试学习笔记二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd51kdq.html">self&comma;parent&comma;this区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxkme9.html">UITabBar - 深度解剖</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xpjx9.html">A Tour of Go  If</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vn2738.html">u盘的超级用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okp35e9.html">pc机安装centos6&period;5，提示sda必须有一个GPT磁盘标签处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o246n9.html">css-a&colon;visited</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o26xj9.html">SolrCloud阶段总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdln5d8.html">Delphi实现WebService带身份认证的数据传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xepx09.html">&lbrack;Head First Python&rsqb;6&period; summary</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zogyr3q.html">在CheckBox中，仅仅允许选择一项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1w6l2q.html">VC问题 IntelliSense&colon;&OpenCurlyDoubleQuote;没有可用的附加信息&rdquo;，&lbrack;请参见&OpenCurlyDoubleQuote;C&plus;&plus;项目 IntelliSense 疑难解答&rdquo;，获得进一步的帮助&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7pnr8.html">改变图像，运用match方法判断</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wzl7oq.html">&lbrack;php基础&rsqb;PHP&period;INI配置&colon;Session配置详细说明教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m5regq.html">Property type &amp;&num;39&semi;id&amp;lt&semi;tabBarDelegate&amp;gt&semi;&amp;&num;39&semi; is incompatible with type &amp;&num;39&semi;id&amp;lt&semi;UITabBarDelegate&amp;gt&semi; &lowbar;Nullable&amp;&num;39&semi; inherited from &amp;&num;39&semi;UITabBar&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1ex559.html">java&lpar;try块语句变量，和匿名类变量生存时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdg7vk8.html">PHP安全设置（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdg7nr8.html">Python一路走来 - python基础 数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xor3z8.html">数据分页SQL语句的比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vg7nn8.html">运行批处理bat文件不出现黑框</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j03j4eq.html">iOS中常用的四种数据持久化方法简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdx5y78.html">Linux下根据进程的名字杀死进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xoge68.html">zabbix 插件使用问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
